; 
    .686                       ; create 32 bit code
    .model flat, stdcall       ; 32 bit memory model
    option casemap :none       ; case sensitive
    .xmm
 
    include \masm32\include\windows.inc
    include \masm32\include\masm32.inc
    include \masm32\include\user32.inc
    include \masm32\include\kernel32.inc
	include \masm32\include\msvcrt.inc
    includelib \masm32\lib\masm32.lib
    includelib \masm32\lib\user32.lib
    includelib \masm32\lib\kernel32.lib
	includelib \masm32\lib\msvcrt.lib
    include \masm32\macros\macros.asm
    include \masm32\macros\timers.asm

    dcopy   PROTO :DWORD,:DWORD,:DWORD
    qcopy   PROTO :DWORD,:DWORD,:DWORD
    _qcopy  PROTO :DWORD,:DWORD,:DWORD
    xcopy   PROTO :DWORD,:DWORD,:DWORD
    _xcopy  PROTO :DWORD,:DWORD,:DWORD
	mmxcopy PROTO :DWORD,:DWORD,:DWORD
	mmxcopy2 PROTO :DWORD,:DWORD,:DWORD

; 
    .data

	align 4

      lpSrc   dd 0
      lpDst  dd 0
    .code
; 
start: 
; 
    BLOCK_SIZE EQU 1024*1024*100
    LOOP_COUNT EQU 20
    _EMMS EQU 1

    mov   lpSrc,alloc(BLOCK_SIZE)
    mov   lpDst,alloc(BLOCK_SIZE)

    invoke memfill,lpSrc,BLOCK_SIZE,"XXXX"
    invoke MemCopy,lpSrc,lpDst,BLOCK_SIZE
    invoke cmpmem,lpSrc,lpDst,BLOCK_SIZE
    print ustr$(eax)

    invoke memfill,lpSrc,BLOCK_SIZE,"YYYY"
    invoke dcopy,lpSrc,lpDst,BLOCK_SIZE
    invoke cmpmem,lpSrc,lpDst,BLOCK_SIZE
    print ustr$(eax)

    invoke memfill,lpSrc,BLOCK_SIZE,"XXXX"
    invoke qcopy,lpSrc,lpDst,BLOCK_SIZE
    invoke cmpmem,lpSrc,lpDst,BLOCK_SIZE
    print ustr$(eax)

    invoke memfill,lpSrc,BLOCK_SIZE,"YYYY"
    invoke _qcopy,lpSrc,lpDst,BLOCK_SIZE
    invoke cmpmem,lpSrc,lpDst,BLOCK_SIZE
    print ustr$(eax)

    invoke memfill,lpSrc,BLOCK_SIZE,"XXXX"
    invoke xcopy,lpSrc,lpDst,BLOCK_SIZE
    invoke cmpmem,lpSrc,lpDst,BLOCK_SIZE
    print ustr$(eax)    

    invoke memfill,lpSrc,BLOCK_SIZE,"YYYY"
    invoke _xcopy,lpSrc,lpDst,BLOCK_SIZE
    invoke cmpmem,lpSrc,lpDst,BLOCK_SIZE
    print ustr$(eax)

    invoke memfill,lpSrc,BLOCK_SIZE,"XXXX"
    invoke mmxcopy,lpSrc,lpDst,BLOCK_SIZE
    invoke cmpmem,lpSrc,lpDst,BLOCK_SIZE
    print ustr$(eax)  

    invoke memfill,lpSrc,BLOCK_SIZE,"XXXX"
    invoke mmxcopy2,lpSrc,lpDst,BLOCK_SIZE
    invoke cmpmem,lpSrc,lpDst,BLOCK_SIZE
    print ustr$(eax)  
    print chr$(13,10)
    print chr$(13,10)

    free  lpDst
    ;jmp   fini

    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
      invoke MemCopy,lpSrc,lpSrc,BLOCK_SIZE
    counter_end
    mov   ebx,eax
    print chr$("MemCopy - rep movsd                         : ")
    print ustr$(ebx)
    print chr$(" cycles",13,10)

    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
      invoke dcopy,lpSrc,lpSrc,BLOCK_SIZE
    counter_end
    mov   ebx,eax
    print chr$("dcopy   - mov reg,mem/mov mem,reg x 8       : ")
    print ustr$(ebx)
    print chr$(" cycles",13,10)

    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
      invoke qcopy,lpSrc,lpSrc,BLOCK_SIZE
    counter_end
    mov   ebx,eax
    print chr$("qcopy   - movq mmx,mem/movq mem,mmx x 1     : ")
    print ustr$(ebx)
    print chr$(" cycles",13,10)

    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
      invoke _qcopy,lpSrc,lpSrc,BLOCK_SIZE
    counter_end
    mov   ebx,eax
    print chr$("_qcopy  - movq mmx,mem/movq mem,mmx x 8     : ")
    print ustr$(ebx)
    print chr$(" cycles",13,10)

    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
      invoke xcopy,lpSrc,lpSrc,BLOCK_SIZE
    counter_end
    mov   ebx,eax
    print chr$("xcopy   - movaps xmm,mem/movaps mem/xmm x 1 : ")
    print ustr$(ebx)
    print chr$(" cycles",13,10)

    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
      invoke _xcopy,lpSrc,lpSrc,BLOCK_SIZE
    counter_end
    mov   ebx,eax
    print chr$("_xcopy  - movaps xmm,mem/movaps mem/xmm x 8 : ")
    print ustr$(ebx)
    print chr$(" cycles",13,10)

    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
      invoke mmxcopy,lpSrc,lpSrc,BLOCK_SIZE
    counter_end
    mov   ebx,eax
    print chr$("mmxcopy  - movq x 8 : ")
    print ustr$(ebx)
    print chr$(" cycles",13,10)

    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
      invoke mmxcopy2,lpSrc,lpSrc,BLOCK_SIZE
    counter_end
    mov   ebx,eax
    print chr$("mmxcopy2  - movq x 8 : ")
    print ustr$(ebx)
    print chr$(" cycles",13,10)

  fini:

    free  lpSrc

    mov   eax,input(13,10,"Press enter to exit...")
    exit

; 
align 4

dcopy proc src:DWORD,dst:DWORD,cnt:DWORD

    LOCAL dcnt  :DWORD

    push ebx
    push esi
    push edi

    mov esi, src
    mov edi, dst
    mov ecx, cnt
    cmp ecx, 32
    jl tail

    shr ecx, 5      ; div by 32
    mov dcnt, ecx

  align 4
  body:
    mov eax, [esi]
    mov ebx, [esi+4]
    mov ecx, [esi+8]
    mov edx, [esi+12]
    mov [edi],    eax
    mov [edi+4],  ebx
    mov [edi+8],  ecx
    mov [edi+12], edx

    mov eax, [esi+16]
    mov ebx, [esi+20]
    mov ecx, [esi+24]
    mov edx, [esi+28]
    mov [edi+16], eax
    mov [edi+20], ebx
    mov [edi+24], ecx
    mov [edi+28], edx

    add esi, 32
    add edi, 32
    sub dcnt, 1
    jnz body

    mov ecx, cnt
    and ecx, 31
    jz bcend

  tail:
    mov al, [esi]
    add esi, 1
    mov [edi], al
    add edi, 1
    sub ecx, 1
    jnz tail

  bcend:

    pop edi
    pop esi
    pop ebx

    ret

dcopy endp

; 

align 4

qcopy proc src:DWORD,dst:DWORD,cnt:DWORD

    LOCAL dcnt:DWORD

    push  ebx
    push  esi
    push  edi

    mov   esi,src
    mov   edi,dst
    mov   ecx,cnt
    cmp   ecx,8
    jl    tail

    shr   ecx,3      ; div by 8
    mov   dcnt,ecx

  align 4
  body:

    movq  mm0,[esi]
    movq  [edi],mm0

    add   esi,8
    add   edi,8
    sub   dcnt,1
    jnz   body

    mov   ecx,cnt
    and   ecx,7 
    jz    bcend

  tail:
    mov   al,[esi]
    add   esi,1
    mov   [edi],al
    add   edi,1
    sub   ecx,1
    jnz   tail

  bcend:

    pop   edi
    pop   esi
    pop   ebx

    ret

qcopy endp

; 

align 4

_qcopy proc src:DWORD,dst:DWORD,cnt:DWORD

    LOCAL dcnt:DWORD

    push  ebx
    push  esi
    push  edi

    mov   esi,src
    mov   edi,dst
    mov   ecx,cnt
    cmp   ecx,64
    jl    tail

    shr   ecx,6      ; div by 64
    mov   dcnt,ecx

  align 4
  body:

    movq  mm0,[esi]
    movq  mm1,[esi+8]
    movq  mm2,[esi+16]
    movq  mm3,[esi+24]
    movq  mm4,[esi+32]
    movq  mm5,[esi+40]
    movq  mm6,[esi+48]
    movq  mm7,[esi+56]

    movq  [edi],   mm0
    movq  [edi+8], mm1
    movq  [edi+16],mm2
    movq  [edi+24],mm3
    movq  [edi+32],mm4
    movq  [edi+40],mm5
    movq  [edi+48],mm6
    movq  [edi+56],mm7

    add   esi,64
    add   edi,64
    sub   dcnt,1
    jnz   body

    mov   ecx,cnt
    and   ecx,63 
    jz    bcend

  tail:
    mov   al,[esi]
    add   esi,1
    mov   [edi],al
    add   edi,1
    sub   ecx,1
    jnz   tail

  bcend:

    pop   edi
    pop   esi
    pop   ebx

    ret

_qcopy endp

; 

align 4

xcopy proc src:DWORD,dst:DWORD,cnt:DWORD

    LOCAL dcnt:DWORD

    push  ebx
    push  esi
    push  edi

    mov   esi,src
    mov   edi,dst
    mov   ecx,cnt
    cmp   ecx,16
    jl    tail

    shr   ecx,4      ; div by 16
    mov   dcnt,ecx

  align 4
  body:

    movaps xmm0,[esi]
    movaps [edi],xmm0

    add   esi,16
    add   edi,16
    sub   dcnt,1
    jnz   body

    mov   ecx,cnt
    and   ecx,15
    jz    bcend

  tail:
    mov   al,[esi]
    add   esi,1
    mov   [edi],al
    add   edi,1
    sub   ecx,1
    jnz   tail

  bcend:

    pop   edi
    pop   esi
    pop   ebx

    ret

xcopy endp

; 

align 4

_xcopy proc src:DWORD,dst:DWORD,cnt:DWORD

    LOCAL dcnt:DWORD

    push  ebx
    push  esi
    push  edi

    mov   esi,src
    mov   edi,dst
    mov   ecx,cnt
    cmp   ecx,128
    jl    tail

    shr   ecx,7      ; div by 128
    mov   dcnt,ecx

  align 4
  body:

    movaps xmm0,[esi]
    movaps xmm1,[esi+16]
    movaps xmm2,[esi+32]
    movaps xmm3,[esi+48]
    movaps xmm4,[esi+64]
    movaps xmm5,[esi+80]
    movaps xmm6,[esi+96]
    movaps xmm7,[esi+112]

    movaps [edi],    xmm0
    movaps [edi+16], xmm1
    movaps [edi+32], xmm2
    movaps [edi+48], xmm3
    movaps [edi+64], xmm4
    movaps [edi+80], xmm5
    movaps [edi+96], xmm6
    movaps [edi+112],xmm7

    add   esi,128
    add   edi,128
    sub   dcnt,1
    jnz   body

    mov   ecx,cnt
    and   ecx,127
    jz    bcend

  tail:
    mov   al,[esi]
    add   esi,1
    mov   [edi],al
    add   edi,1
    sub   ecx,1
    jnz   tail

  bcend:

    pop   edi
    pop   esi
    pop   ebx

    ret

_xcopy endp

OPTION PROLOGUE:PROLOGUEDEF
OPTION EPILOGUE:EPILOGUEDEF

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 16

mmxcopy proc src:DWORD,dst:DWORD,lenx:DWORD
	mov ecx,[esp+3*4]			; len
	add esp,-3*4				; 3 DWORDs
	mov [esp],ecx				;
	mov [esp-4],esi				;
	mov [esp-8],edi				;
	mov esi,[esp+1*4+(3*4)]			; src
	mov edi,[esp+2*4+(3*4)]			; dst
	cmp ecx,64				;
	;jz @exit				;
	jb @tail				;
	shr ecx,6				;
						;
	align 8					;
@@:						;
	movq mm0,[esi]				;
	movq mm1,[esi+1*8]			;
	movq mm2,[esi+2*8]			;
	movq mm3,[esi+3*8]			;
	movq mm4,[esi+4*8]			;
	movq mm5,[esi+5*8]			;
	movq mm6,[esi+6*8]			;
	movq mm7,[esi+7*8]			;
						;
	movq [edi],mm0				;
	movq [edi+1*8],mm1			;
	movq [edi+2*8],mm2			;
	movq [edi+3*8],mm3			;
	movq [edi+4*8],mm4			;
	movq [edi+5*8],mm5			;
	movq [edi+6*8],mm6			;
	movq [edi+7*8],mm7			;
						;
	add esi,64				;
	add edi,64				;
	sub ecx,1				;
	jnz @B					;
						;
	and dword ptr [esp],63			;
	jz @exit				;
	mov ecx,[esp]				;
						;
@tail:						;
	;cld					;
	rep movsb				;
@exit:						;
	mov edi,[esp-8]				;
	mov esi,[esp-4]				;
	add esp,3*4				;
	ret 3*4					;
mmxcopy endp

OPTION PROLOGUE:PROLOGUEDEF
OPTION EPILOGUE:EPILOGUEDEF

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 16

mmxcopy2 proc src:DWORD,dst:DWORD,lenx:DWORD
	mov ecx,[esp+3*4]			; len
	add esp,-3*4				; 3 DWORDs
	mov [esp],ecx				;
	mov [esp-4],esi				;
	mov [esp-8],edi				;
	mov esi,[esp+1*4+(3*4)]			; src
	mov edi,[esp+2*4+(3*4)]			; dst
	cmp ecx,64				;
	;jz @exit				;
	jb @tail				;
	shr ecx,6				;
	xor edx,edx				;
						;
	align 8					;
@@:						;
	movq mm0,[esi+edx*8+0]			;
	movq mm1,[esi+edx*8+8]			;
	movq mm2,[esi+edx*8+16]			;
	movq mm3,[esi+edx*8+24]			;
	movq mm4,[esi+edx*8+32]			;
	movq mm5,[esi+edx*8+40]			;
	movq mm6,[esi+edx*8+48]			;
	movq mm7,[esi+edx*8+56]			;
						;
	movq [edi+edx*8+0],mm0			;
	movq [edi+edx*8+8],mm1			;
	movq [edi+edx*8+16],mm2			;
	movq [edi+edx*8+24],mm3			;
	movq [edi+edx*8+32],mm4			;
	movq [edi+edx*8+40],mm5			;
	movq [edi+edx*8+48],mm6			;
	movq [edi+edx*8+56],mm7			;
						;
	add edx,1				;
	cmp edx,ecx				;
	jb @B					;
						;
	and dword ptr [esp],63			;
	jz @exit				;
	mov ecx,[esp]				;
						;
@tail:						;
	;cld					;
	rep movsb				;
@exit:						;
	mov edi,[esp-8]				;
	mov esi,[esp-4]				;
	add esp,3*4				;
	ret 3*4					;
mmxcopy2 endp

OPTION PROLOGUE:PROLOGUEDEF
OPTION EPILOGUE:EPILOGUEDEF

; 
end start
